#the commands understood by the MSP
#"read" commands 1-20
C_EPOCH_READ = 1    # reads the epoch value
C_JOB_TB_READ = 2    # read the job table
C_JOB_NUM_READ = 3    # get the number of jobs stored in the table
C_DATA_READ = 4    # read the sensor data table
C_DATA_NUM_READ = 5    # read the geophone data back
C_READ_VERSION = 6    # read the version of the code running on the msp
C_OUTPUT_STATUS = 7     # binary respresentation of the outputs
C_LED_STATUS = 8    # LED status
C_DEBUG_STATUS = C_LED_STATUS
C_BONE_STATUS = 9    # Beagle bone power staus


# "write" commands 21-40
C_EPOCH_SET = 21    # set the epoch
C_JOB_TB_ADD = 22    # add a job to the table
C_JOB_DISABLE = 23    # disable a job the already exists
C_JOB_ENABLE = 24    # enable a job that already exists

# "action" commands 41-60
C_POWER_DOWN = 41    # turn off everything
C_POWER_DOWN_GUM = 42    # turn off the gumstix
C_SENSOR_READ = 43    # instantaneous read of the sensors
C_OUTPUT_ON = 44    # turn on pcon output as specified by mask
C_OUTPUT_OFF = 45    # turn on spcon output as specified by mask
C_LED_ON = 48
C_LED_OFF = 49
# "clear" commands 61-80
C_JOB_TB_CLEAR = 61    # clear the job table
C_DATA_CLEAR = 62    # clear the data tables

# response codes from the msp
S_OK = 1
S_CMD_CANCEL = 96
S_INVALID_JOB = 97
S_TOO_MANY_JOBS = 98
S_ERROR = 99


class MspCmd:
    """Defines the command as sent to the msp"""

    def __init__(self, cmd, cmdType=None, exec_time=None,
                job_interval=None, power_time=None,
                power_mask=None, sensor_mask=None):
        self.cmd = cmd
        self.cmdType = cmdType
        self.exec_time = exec_time
        self.job_interval = job_interval
        self.power_time = power_time
        self.power_mask = power_mask
        self.sensor_mask = sensor_mask
