#!/usr/bin/env python

import iceCape
from conversions import conversions
from gwlogging import logger
from variables import BASE, FARM, REF, CAM

from sys import argv

__mode__ = None


def read_currents():
    ic = iceCape.iceCape()
    raw_wind = ic.read_sensors(iceCape.WIND)
    raw_solar = ic.read_sensors(iceCape.SOLAR)
    raw_cafe = ic.read_sensors(iceCape.CAFE)

    raw_solar_v = ic.read_sensors(iceCape.SOLAR_V)
    raw_wind_v = ic.read_sensors(iceCape.WIND_V)

    print "Raw Cafe: current %d" % raw_cafe
    print "Raw Wind: current %d voltage %d" % (raw_wind, raw_wind_v)
    print "Raw Solar: current %d voltage %d" % (raw_solar, raw_solar_v)


if __name__ == "__main__":
    for arg in argv[1:]:
        if arg == '-B':
            logger.info("Base mode activated")
            __mode__ = BASE
        elif arg == '-R':
            logger.info("Ref mode activated")
            __mode__ = REF
        elif arg == '-C':
            logger.info("Cam mode activated")
            __mode__ = CAM
            __camera__ = True
            __comms__ = False
        elif arg == '-F':
            logger.info("farm mode activated")
            __mode__ = FARM
        else:
            print "Useage: %s  -[B|R|F|C]" % (argv[0])
            print "\t-C: Camera only mode"
            print "\t-B: Base station mode - enables probes"
            print "\t-R: Reference station mode - disables probes"
            print ("\t-F: Farm station mode - only does comms stuff does not" +
                            " do any power management")
            exit(2)

    if __mode__ is None:
        logger.critical("Must set a mode")
        exit(1)
    else:
        read_currents()
