#include <vector>
#include "OpenIMAJGrabber.h"
#include <iostream>
#include <fstream>
#include <sstream>
#include <string.h>

using namespace std;

int main (int argc, const char * argv[])
{
   OpenIMAJGrabber * grabber = new OpenIMAJGrabber();
   DeviceList * devices = grabber->getVideoDevices(); 
   
   if (argc == 1) {
       if (devices->getNumDevices() == 0) {
           std::cout << "no devices found\n";
       }

       for (int i=0; i<devices->getNumDevices(); i++) {
           std::cout << i;
	   std::cout << "\t->\t";
           std::cout << devices->getDevice(i)->getName();
           std::cout << "\n";
       }

       return 0;
   }

   if (argc > 5 || argc < 3) {
	std::cerr << "grabber deviceId filename [width] [height]\n";
	return 1;
   }

   int deviceId = 0;
   const char * filename;
   int width = 640;
   int height = 480;

   sscanf(argv[1], "%d", &deviceId);
   filename = argv[2];
   if (argc >= 4) sscanf(argv[3], "%d", &width);
   if (argc == 5) sscanf(argv[4], "%d", &height);


   if (!grabber->startSession(width, height, 1.0, devices->getDevice(deviceId))) {
       std::cout << "Error starting grabber\n";
       return 1;
   }

   grabber->nextFrame();
   unsigned char * data = grabber->getImage();

   if (strncmp("-", filename, 1) == 0) {
      std::cout << "P6\n" << width << " " << height << "\n255\n";
      std::cout.write((const char *)data, 3*width * height);
   } else {
      ofstream myfile;
      myfile.open(filename);
      myfile << "P6\n" << width << " " << height << "\n255\n";
      myfile.write((const char *)data, 3*width * height);
      myfile.close();
   }

   printf("done\n");

   grabber->stopSession();
   delete grabber;

   return 0;
}
